## perl 5.003.07

=== vms/Makefile ===
#> This file produced from Descrip.MMS by mms2make.pl
#> Lines beginning with "#>" were commented out during the
#> conversion process.  For more information, see mms2make.pl
#>
# Makefile for perl5 on VMS
# Last revised 22-Mar-1996 by Charles Bailey  bailey@genetics.upenn.edu
#
#
#	tidy      -- purge files generated by executing this file
#	clean     -- remove all intermediate (e.g. object files, C files generated
#	             during build) files generated by executing this file,
#	             but leave `installable' files (images, library) intact
#	realclean -- remove all files generated by executing this file
#	cleansrc  -- `realclean' + purge *.c,*.h,Makefile
#	crtl.opt  -- compiler-specific linker options file (made automatically)
#

#### Start of system configuration section. ####


# File type to use for object files
# File type to use for object libraries
# File type to use for executable images
# File type to use for object files
O = .obj
# File type to use for object libraries
OLB = .olb
# File type to use for executable images
E = .exe

ARCH = VMS_VAX
OBJVAL = $@

# Updated by fndvers.com -- do not edit by hand
PERL_VERSION = 5_00304#


ARCHDIR =  [.lib.$(ARCH).$(PERL_VERSION)]
ARCHCORE = [.lib.$(ARCH).$(PERL_VERSION).CORE]
ARCHAUTO = [.lib.$(ARCH).$(PERL_VERSION).auto]




# -fno-builtin avoids bug in gcc up to version 2.6.2 which can destroy
# data when memcpy() is called on large (>64 kB) blocks of memory
# (fixed in gcc 2.6.3)
XTRAOBJS = 
LIBS1 = $(XTRAOBJS)
DBGSPECFLAGS = /Show=(Source,Include,Expansion)
# Some versions of DECCRTL on AXP have a bug in chdir() which causes the change
# to persist after the image exits, even when this was not requested, iff
# SYSNAM is enabled.  This is fixed in CSC Patch # AXPACRT04_061, but turning
# off SYSNAM for the MM[SK] subprocess doesn't hurt anything, so we do it
# just in case.
.first:
	@ $$@[.vms]fndvers.com "" "" "[.vms]Makefile"
	@ If f$$TrnLnm("Sys").eqs."" .and. f$$TrnLnm("VAXC$Include").eqs."" Then Define/NoLog SYS sys$$Library
	@ If f$$TrnLnm("Sys").eqs."" .and. f$$TrnLnm("VAXC$Include").nes."" Then Define/NoLog SYS VAXC$Include

XTRACCFLAGS = /Include=[]/Object=$(O)
XTRADEF =
LIBS2 = sys$$Share:VAXCRTL/Shareable


DBGCCFLAGS = /NoList
DBGLINKFLAGS = /NoMap
DBG = 

# N.B. the targets for $(SOCKC) and $(SOCKH) assume that the permanent
# copies live in [.vms], and the `clean' target will delete copies of
# these files in the current default directory.
SOCKDEF =
SOCKLIB =
SOCKC =
SOCKH =
SOCKCLIS =
SOCKHLIS =
SOCKOBJ =
SOCKPM =

# C preprocessor manifest "DEBUGGING" ==> perl -D, not the VMS debugger
CFLAGS = /Define=(DEBUGGING$(SOCKDEF)$(XTRADEF))$(XTRACCFLAGS)$(DBGCCFLAGS)
LINKFLAGS = $(DBGLINKFLAGS)

MAKE = $(MMS)
MAKEFILE = [.VMS]Makefile   # this file
NOOP = continue

# Macros to invoke a copy of miniperl during the build.  Targets which
# are built using these macros should depend on $(MINIPERL_EXE)
MINIPERL_EXE = sys$$Disk:[]miniperl$(E)
MINIPERL = MCR $(MINIPERL_EXE) "-I[.lib]"
XSUBPP = $(MINIPERL) [.lib.extutils]xsubpp -noprototypes
# Macro to invoke a preexisting copy of Perl.  This is used to regenerate
# some header files when rebuilding Perl, but premade versions are provided
# in the distribution, so it's OK if this doesn't work; it's here to make
# life easier for those who modify Perl and rebuild it.
INSTPERL = perl

# Space-separated list of "static" extensions to build into perlshr (case counts).
MYEXT = DynaLoader
# object files for these extensions; the trailing comma is required if
# there are any object files specified
# These must be built separately, or you must add rules below to build them
myextobj = [.ext.dynaloader]dl_vms$(O),
EXT = $(MYEXT)
extobj = $(myextobj)


#### End of system configuration section. ####


h1 = EXTERN.h, INTERN.h, XSUB.h, av.h, config.h, cop.h, cv.h
h2 = embed.h, form.h, gv.h, handy.h, hv.h, keywords.h, mg.h, op.h
h3 = opcode.h, patchlevel.h, perl.h, perly.h, pp.h, proto.h, regcomp.h
h4 = regexp.h, scope.h, sv.h, vmsish.h, util.h, perlio.h, perlsdio.h
h = $(h1), $(h2), $(h3), $(h4) $(SOCKHLIS)

c1 = av.c, scope.c, op.c, doop.c, doio.c, dump.c, hv.c, mg.c, universal.c, perlio.c
c2 = perl.c, perly.c, pp.c, pp_hot.c, pp_ctl.c, pp_sys.c, regcomp.c, regexec.c
c3 = gv.c, sv.c, taint.c, toke.c, util.c, deb.c, run.c, globals.c, vms.c $(SOCKCLIS)

c = $(c1), $(c2), $(c3), miniperlmain.c, perlmain.c

obj1 = perl$(O), gv$(O), toke$(O), perly$(O), op$(O), regcomp$(O), dump$(O), util$(O), mg$(O), perlio$(O)
obj2 = hv$(O), av$(O), run$(O), pp_hot$(O), sv$(O), pp$(O), scope$(O), pp_ctl$(O), pp_sys$(O)
obj3 = doop$(O), doio$(O), regexec$(O), taint$(O), deb$(O), universal$(O), globals$(O), vms$(O) $(SOCKOBJ)

obj = $(obj1), $(obj2), $(obj3)

ac1 = $(ARCHCORE)EXTERN.h $(ARCHCORE)INTERN.h  $(ARCHCORE)XSUB.h $(ARCHCORE)av.h
ac2 = $(ARCHCORE)config.h $(ARCHCORE)cop.h $(ARCHCORE)cv.h $(ARCHCORE)embed.h
ac3 = $(ARCHCORE)form.h $(ARCHCORE)gv.h $(ARCHCORE)handy.h $(ARCHCORE)hv.h
ac4 = $(ARCHCORE)keywords.h $(ARCHCORE)mg.h $(ARCHCORE)op.h $(ARCHCORE)opcode.h
ac5 = $(ARCHCORE)patchlevel.h $(ARCHCORE)perl.h $(ARCHCORE)perly.h
ac6 = $(ARCHCORE)pp.h $(ARCHCORE)proto.h $(ARCHCORE)regcomp.h $(ARCHCORE)perlio.h $(ARCHCORE)perlsdio.h
ac7 = $(ARCHCORE)regexp.h $(ARCHCORE)scope.h $(ARCHCORE)sv.h $(ARCHCORE)util.h
ac8 = $(ARCHCORE)vmsish.h $(ARCHCORE)$(DBG)libperl$(OLB) $(ARCHCORE)perlshr_attr.opt
ac9 = $(ARCHCORE)$(DBG)perlshr_bld.opt
acs =

CRTL = []crtl.opt
CRTLOPTS =,$(CRTL)/Options

.suffixes:

.suffixes: $(O) .c .xs

.xs.c :
	$(XSUBPP) $< >$@


.c$(O) :
	$(CC) $(CFLAGS) $<

.xs$(O) :
	$(XSUBPP) $< >$(MMS$SOURCE_NAME).c
	$(CC) $(CFLAGS) $(MMS$SOURCE_NAME).c


all : base extras libmods utils podxform archcorefiles preplibrary perlpods
	@ $(NOOP)
base : miniperl perl
	@ $(NOOP)
extras : Fcntl FileHandle IO Opcode libmods utils podxform
	@ $(NOOP)
libmods : [.lib]Config.pm $(ARCHDIR)Config.pm [.lib]DynaLoader.pm [.lib.VMS]Filespec.pm 
	@ $(NOOP)
utils : [.lib.pod]perldoc [.lib.ExtUtils]Miniperl.pm [.utils]c2ph [.utils]h2ph [.utils]h2xs [.lib]perlbug
	@ $(NOOP)
podxform : [.lib.pod]pod2text [.lib.pod]pod2html [.lib.pod]pod2latex [.lib.pod]pod2man
	@ $(NOOP)

pod1 = [.lib.pod]perl.pod [.lib.pod]perlbook.pod [.lib.pod]perlbot.pod [.lib.pod]perlcall.pod
pod2 = [.lib.pod]perldata.pod [.lib.pod]perldebug.pod [.lib.pod]perldiag.pod [.lib.pod]perldsc.pod
pod3 = [.lib.pod]perlembed.pod [.lib.pod]perlform.pod [.lib.pod]perlfunc.pod [.lib.pod]perlguts.pod
pod4 = [.lib.pod]perlipc.pod [.lib.pod]perllol.pod [.lib.pod]perlmod.pod [.lib.pod]perlobj.pod
pod5 = [.lib.pod]perlop.pod [.lib.pod]perlovl.pod [.lib.pod]perlpod.pod [.lib.pod]perlre.pod
pod6 = [.lib.pod]perlref.pod [.lib.pod]perlrun.pod [.lib.pod]perlsec.pod [.lib.pod]perlstyle.pod
pod7 = [.lib.pod]perlsub.pod [.lib.pod]perlsyn.pod [.lib.pod]perltie.pod [.lib.pod]perltoc.pod
pod8 = [.lib.pod]perltrap.pod [.lib.pod]perlvar.pod [.lib.pod]perlxs.pod [.lib.pod]perlxstut.pod

perlpods : $(pod1) $(pod2) $(pod3) $(pod4) $(pod5) $(pod6) $(pod7) $(pod8) [.lib.pod]perlvms.pod
	@ $(NOOP)

archcorefiles :  $(ac1) $(ac2) $(ac3) $(ac4) $(ac5) $(ac6) $(ac7) $(ac8) $(ac9) $(acs) $(ARCHAUTO)time.stamp
	@ $(NOOP)

miniperl : $(DBG)miniperl$(E)
	@ Continue
miniperl_objs = miniperlmain$(O), $(obj)
$(MINIPERL_EXE) :  miniperlmain$(O), $(DBG)libperl$(OLB) $(CRTL)
	Link $(LINKFLAGS)/NoDebug/NoMap/NoFull/NoCross/Exe=$@ miniperlmain$(O), $(DBG)libperl$(OLB)/Library/Include=globals $(CRTLOPTS)
$(DBG)miniperl$(E) :  $(miniperl_objs), $(DBG)libperl$(OLB) $(CRTL)
	Link $(LINKFLAGS)/Exe=$@ miniperlmain$(O),$(DBG)libperl$(OLB)/Library/Include=globals  $(CRTLOPTS)

$(DBG)libperl$(OLB) : $(obj)
	@ If f$$Search("$@").eqs."" Then Library/Object/Create $(MMS$TARGET)
	Library/Object/Replace $@ $(obj1)
	Library/Object/Replace $@ $(obj2)
	Library/Object/Replace $@ $(obj3)

perlmain.c : miniperlmain.c $(MINIPERL_EXE) [.vms]writemain.pl
	$(MINIPERL) [.VMS]Writemain.pl "$(EXT)"

perl : $(DBG)perl$(E)
	@ Continue
$(DBG)perl$(E) : perlmain$(O), $(DBG)perlshr$(E), $(MINIPERL_EXE)
	@ $$@[.vms]genopt "PerlShr.Opt/Write" "|" "''f$$Environment("Default")'$(DBG)PerlShr$(E)/Share"
	Link $(LINKFLAGS)/Exe=$@ perlmain$(O), perlshr.opt/Option, perlshr_attr.opt/Option

$(DBG)perlshr$(E) : $(DBG)libperl$(OLB) $(extobj) $(DBG)perlshr_xtras.ts
	Link /NoTrace$(LINKFLAGS)/Share=$@ $(extobj) []$(DBG)perlshr_bld.opt/Option, perlshr_attr.opt/Option

# The following files are built in one go by gen_shrfls.pl:
#  perlshr_attr.opt, $(DBG)perlshr_bld.opt - VAX and AXP
#  perlshr_gbl*.mar, perlshr_gbl*$(O) - VAX only
# The song and dance with gen_shrfls.opt accomodates DCL's 255 character
# line length limit.
# This is a backup target used only with older versions of the DECCRTL which
# can't deal with pipes properly.  See ReadMe.VMS for details.
$(DBG)perlshr_xtras.ts : perl.h config.h vmsish.h proto.h [.vms]gen_shrfls.pl $(MINIPERL_EXE) $(MAKEFILE) $(CRTL)
	@ $(MINIPERL) -e "print join('|',@ARGV),'|';" "$(CC)$(CFLAGS)" >gen_shrfls.opt
	@ $(MINIPERL) -e "print join('|',@ARGV);" "$(O)" "$(DBG)" "$(OLB)" "$(EXT)" "$(CRTL)" >>gen_shrfls.opt
	$(MINIPERL) [.vms]gen_shrfls.pl -f gen_shrfls.opt
	@ Delete/NoLog/NoConfirm gen_shrfls.opt;
	@ If f$$Search("$(DBG)perlshr_xtras.ts").nes."" Then Delete/NoLog/NoConfirm $(DBG)perlshr_xtras.ts;*
	@ Copy _NLA0: $(DBG)perlshr_xtras.ts

$(ARCHDIR)config.pm : [.lib]config.pm
	Create/Directory $(ARCHDIR)
	Copy [.lib]config.pm $@

# Once again, we accomodate DCL's 255 character buffer
[.lib]config.pm : [.vms]config.vms [.vms]genconfig.pl $(MINIPERL_EXE)
	@ $(MINIPERL) -e "print join('|',@ARGV),'|';" "cc=$(CC)$(CFLAGS)" >genconfig.opt
	@ $(MINIPERL) -e "print join('|',@ARGV),'|';" "ldflags=$(LINKFLAGS)|obj_ext=$(O)|exe_ext=$(E)|lib_ext=$(OLB)" >>genconfig.opt
	$(MINIPERL) [.VMS]GenConfig.Pl -f genconfig.opt
	@ Delete/NoLog/NoConfirm genconfig.opt;
	$(MINIPERL) ConfigPM.

[.ext.dynaloader]dl_vms.c : [.ext.dynaloader]dl_vms.xs $(MINIPERL_EXE)
	$(XSUBPP) [.ext.dynaloader]dl_vms.xs >$@

[.ext.dynaloader]dl_vms$(O) : [.ext.dynaloader]dl_vms.c
	$(CC) $(CFLAGS) /Object=$@ [.ext.dynaloader]dl_vms.c

[.lib]DynaLoader.pm : [.ext.dynaloader]dynaloader.pm
	Copy/Log/NoConfirm [.ext.dynaloader]dynaloader.pm [.lib]DynaLoader.pm
	@ If f$$Search("[.lib]auto.dir").eqs."" Then Create/Directory [.lib.auto]
	@ $(MINIPERL) -e "use AutoSplit; autosplit_lib_modules(@ARGV)" [.lib]DynaLoader.pm

Opcode : [.lib]Opcode.pm [.lib]ops.pm [.lib]Safe.pm [.lib.auto.Opcode]Opcode$(E)
	@ $(NOOP)

[.lib]Opcode.pm : [.ext.Opcode]Makefile
	@ If f$$Search("[.lib]auto.dir").eqs."" Then Create/Directory [.lib.auto]
	@ Set Default [.ext.Opcode]
	$(MMS)
	@ Set Default [--]

[.lib]ops.pm : [.ext.Opcode]Makefile
	@ If f$$Search("[.lib]auto.dir").eqs."" Then Create/Directory [.lib.auto]
	@ Set Default [.ext.Opcode]
	$(MMS)
	@ Set Default [--]

[.lib]Safe.pm : [.ext.Opcode]Makefile
	@ If f$$Search("[.lib]auto.dir").eqs."" Then Create/Directory [.lib.auto]
	@ Set Default [.ext.Opcode]
	$(MMS)
	@ Set Default [--]

[.lib.auto.Opcode]Opcode$(E) : [.ext.Opcode]Makefile
	@ Set Default [.ext.Opcode]
	$(MMS)
	@ Set Default [--]

# Add "-I[--.lib]" t $(MINIPERL) so we use this copy of lib after C<chdir>
# ${@} necessary to distract different versions of MM[SK]/make
[.ext.Opcode]Makefile : [.ext.Opcode]Makefile.PL $(ARCHDIR)Config.pm [.lib.VMS]Filespec.pm [.lib]DynaLoader.pm $(DBG)perlshr$(E)
	$(MINIPERL) "-I[--.lib]" -e "chdir('[.ext.Opcode]') or die $!; do 'Makefile.PL'; print ${@} if ${@};" "INST_LIB=[--.lib]" "INST_ARCHLIB=[--.lib]"

FileHandle : [.lib]FileHandle.pm [.lib.auto.FileHandle]FileHandle$(E)
	@ $(NOOP)

[.lib]FileHandle.pm : [.ext.FileHandle]Makefile
	@ If f$$Search("[.lib]auto.dir").eqs."" Then Create/Directory [.lib.auto]
	@ Set Default [.ext.FileHandle]
	$(MMS)
	@ Set Default [--]

[.lib.auto.FileHandle]FileHandle$(E) : [.ext.FileHandle]Makefile
	@ Set Default [.ext.FileHandle]
	$(MMS)
	@ Set Default [--]

# Add "-I[--.lib]" t $(MINIPERL) so we use this copy of lib after C<chdir>

## perl 5.004.05-2

=== debian/changelog ===
perl (5.004.05-2) unstable; urgency=low

  * New release of fake packages.  They should all be priority extra.

 -- Darren Stalder <torin@daft.com>  Tue, 17 Aug 1999 03:11:02 -0700

perl (5.004.05-1) unstable; urgency=low

  * Initial release of fake packages.  These are here only to ease the
    upgrade to versioned Perl.  Feel free to remove them once installed.
  * Release to Incoming on master.

 -- Darren Stalder <torin@daft.com>  Thu,  1 Jul 1999 01:53:19 -0700

** Local Variables: **
** mode:debian-changelog **
** change-log-default-name:"changelog" **
** fill-prefix:"  " **
** End: **

=== debian/control ===
Section: interpreters
Maintainer: Darren Stalder <torin@daft.com>
Source: perl
Standards-Version: 2.5.0

Package: perl
Priority: extra
Architecture: all
Depends: perl-5.004, perl-5.004-doc
Provides: io
Replaces: io
Conflicts: io
Description: Fake package used for a smooth upgrade
 This package depends on perl-5.004. Perl-5.005 will conflict
 with perl so that all dependencies on perl will have to have
 vanished before perl-5.005 will be installed. The scripts and
 non-binary modules have to depend on perl5 and the
 binary modules on perl-5.005 (or whatever is the latest version
 of perl available in Debian).
 .
 It does also contain the io provides/replaces/conflicts. This
 has been removed from the perl-5.00X since io has disappeared
 a long time ago.

Package: perl-debug
Priority: extra
Architecture: all
Depends: perl (=${Source-Version}), perl-5.004-debug
Description: Fake package used for a smooth upgrade
 This package depends on perl-5.004-debug.  It exists so that
 apt/dselect will automatically install perl-5.004-debug if you have
 perl-debug installed already.
 .
 Feel free to remove this package after it's been installed.

Package: perl-suid
Priority: extra
Architecture: all
Depends: perl (=${Source-Version}), perl-5.004-suid
Description: Fake package used for a smooth upgrade
 This package depends on perl-5.004-suid.  It exists so that
 apt/dselect will automatically install perl-5.004-suid if you have
 perl-suid installed already.
 .
 Feel free to remove this package after it's been installed.

=== debian/rules ===
#! /usr/bin/make -f
## debian/rules to build the fake upgrade Perl debian packages

build:
	true

binary-indep:
	install -d debian/tmp/DEBIAN
	install -d debian/tmp-debug/DEBIAN
	install -d debian/tmp-suid/DEBIAN
	install -d debian/tmp/usr/doc
	install -d debian/tmp-debug/usr/doc
	install -d debian/tmp-suid/usr/doc

	ln -s perl-5.004       debian/tmp/usr/doc/perl
	ln -s perl-5.004-debug debian/tmp-debug/usr/doc/perl-debug
	ln -s perl-5.004-suid  debian/tmp-suid/usr/doc/perl-suid

	chmod -R go=rX debian/tmp debian/tmp-debug debian/tmp-suid
	chmod -R u+w   debian/tmp debian/tmp-debug debian/tmp-suid

	dpkg-gencontrol -pperl
	dpkg-gencontrol -pperl-debug -Pdebian/tmp-debug
	dpkg-gencontrol -pperl-suid  -Pdebian/tmp-suid
	chmod 644 debian/tmp/DEBIAN/control debian/tmp-debug/DEBIAN/control debian/tmp-suid/DEBIAN/control

	chown -R root:root debian/tmp debian/tmp-debug debian/tmp-suid
	dpkg --build debian/tmp       ..
	dpkg --build debian/tmp-debug ..
	dpkg --build debian/tmp-suid  ..

binary-arch:
	true
# There are no architecture-dependent files to be uploaded
# generated by this package.  If there were any, they would be
# made here.


binary: binary-indep binary-arch

clean:
	-rm -rf *~ debian/*~ debian/files*
	-[ -d debian/tmp ] && rm -rf debian/tmp debian/tmp-debug debian/tmp-suid 2>/dev/null

.PHONY: binary binary-arch binary-indep clean build

## perl 5.8.7-1

=== Makefile ===
# $Id: Makefile,v 1.4 2006/01/17 06:44:58 frol Exp $
# 

include $(TOPDIR)/rules.mk

PKG_NAME:=perl
PKG_VERSION:=5.8.7
PKG_RELEASE:=1
PKG_MD5SUM:=9a175d6ccbb5d9b41ffac5073ff9cc3c

PKG_SOURCE_URL:=ftp://ftp.cpan.org/pub/CPAN/src/5.0 \
	        ftp://ftp.mpi-sb.mpg.de/pub/perl/CPAN/src/5.0 \
	   	ftp://ftp.gmd.de/mirrors/CPAN/src/5.0 \
		ftp://ftp.funet.fi/pub/languages/perl/CPAN/src/5.0
PKG_SOURCE:=$(PKG_NAME)-$(PKG_VERSION).tar.bz2
PKG_CAT:=bzcat

PKG_BUILD_DIR:=$(BUILD_DIR)/perl/$(PKG_NAME)-$(PKG_VERSION)
PKG_INSTALL_DIR:=$(PKG_BUILD_DIR)/ipkg-install

include $(TOPDIR)/package/rules.mk

$(eval $(call PKG_template,PERL,perl,$(PKG_VERSION)-$(PKG_RELEASE),$(ARCH)))

PKG_DIR:=${shell pwd}

$(PKG_BUILD_DIR)/.stage1:
	@echo ""
	@echo "===> Stage 1: Configure host perl"
	@echo ""
	mkdir -p $(PKG_BUILD_DIR)/host-perl
	(cd $(PKG_BUILD_DIR)/host-perl && sh ../Configure -der -Dmksymlinks)
	touch $@

$(PKG_BUILD_DIR)/.stage2: $(PKG_BUILD_DIR)/.stage1 $(PKG_BUILD_DIR)/.stage1
	@echo ""
	@echo "===> Stage 2: Build host miniperl binary"
	@echo ""
	$(MAKE) -C $(PKG_BUILD_DIR)/host-perl miniperl
	touch $@

$(PKG_BUILD_DIR)/.stage3: $(PKG_BUILD_DIR)/.stage2
	@echo ""
	@echo "===> Stage 3: Configure target perl"
	@echo ""
	-$(MAKE) -C $(PKG_BUILD_DIR) clean
	mkdir -p $(PKG_BUILD_DIR)/target-bin
	sed -e 's!%%CC%%!${TARGET_CC}!g' \
		-e 's!%%CFLAGS%%!${TARGET_CFLAGS} -DUSE_CROSS_COMPILE -I${STAGING_DIR}/include -I${STAGING_DIR}/usr/include!g' \
		-e 's!%%CPP%%!${TARGET_CROSS}gcc -E!g' \
		-e 's!%%AR%%!${TARGET_CROSS}ar!g' \
		-e 's!%%LD%%!${TARGET_CROSS}gcc!g' \
		-e 's!%%LDFLAGS%%!-rdynamic -L${STAGING_DIR}/lib -L${STAGING_DIR}/usr/lib!g' \
		-e 's!%%LIBDIRS%%!${STAGING_DIR}/lib ${STAGING_DIR}/usr/lib!g' \
		-e 's!%%INCDIRS%%!${STAGING_DIR}/include ${STAGING_DIR}/usr/include!g' \
		$(PKG_DIR)/files/config.sh-mipsel-linux-uclibc.in \
		> $(PKG_BUILD_DIR)/config.sh
	(cd $(PKG_BUILD_DIR) && ./Configure -S)
	touch $@

$(PKG_BUILD_DIR)/.stage4: $(PKG_BUILD_DIR)/.stage3
	@echo ""
	@echo "===> Stage 4: Build target miniperl binary"
	@echo ""
	-rm -f $(PKG_BUILD_DIR)/miniperl
	$(MAKE) -C $(PKG_BUILD_DIR) miniperl
	install -m 0755 $(PKG_BUILD_DIR)/miniperl $(PKG_BUILD_DIR)/target-bin/
	touch $@

$(PKG_BUILD_DIR)/.stage5: $(PKG_BUILD_DIR)/.stage4
	@echo ""
	@echo "===> Stage 5: Build target perl binary"
	@echo ""
	-rm -f $(PKG_BUILD_DIR)/miniperl $(PKG_BUILD_DIR)/perl
	install -m 0755 $(PKG_BUILD_DIR)/host-perl/miniperl $(PKG_BUILD_DIR)/
	touch $(PKG_BUILD_DIR)/miniperl
	$(MAKE) -C $(PKG_BUILD_DIR) perl
	install -m 0755 $(PKG_BUILD_DIR)/perl $(PKG_BUILD_DIR)/target-bin/
	touch $@

$(PKG_BUILD_DIR)/.stage6: $(PKG_BUILD_DIR)/.stage5
	@echo ""
	@echo "===> Stage 6: Build target extensions and utils"
	@echo ""
	-rm -f $(PKG_BUILD_DIR)/miniperl $(PKG_BUILD_DIR)/perl
	install -m 0755 $(PKG_BUILD_DIR)/host-perl/miniperl \
		$(PKG_BUILD_DIR)/
	ln -sf miniperl $(PKG_BUILD_DIR)/perl
	touch $(PKG_BUILD_DIR)/miniperl $(PKG_BUILD_DIR)/perl
	$(MAKE) -C $(PKG_BUILD_DIR)
	touch $@

$(PKG_BUILD_DIR)/.stage7: $(PKG_BUILD_DIR)/.stage6
	@echo ""
	@echo "===> Stage 7: Install Perl into staging dir"
	@echo ""
	-rm -f $(PKG_BUILD_DIR)/perl
	install -m 0755 $(PKG_BUILD_DIR)/host-perl/miniperl \
		$(PKG_BUILD_DIR)/perl
	(cd $(PKG_BUILD_DIR) && ./perl installperl \
		--destdir=$(STAGING_DIR))
	touch $@

$(PKG_BUILD_DIR)/.stage8: $(PKG_BUILD_DIR)/.stage7
	@echo ""
	@echo "===> Stage 8: Install Perl into a temporary root"
	@echo ""
	-rm -f $(PKG_BUILD_DIR)/perl
	install -m 0755 $(PKG_BUILD_DIR)/target-bin/perl \
		$(PKG_BUILD_DIR)/
	-rm -rf $(PKG_INSTALL_DIR)
	mkdir -p $(PKG_INSTALL_DIR)
	(cd $(PKG_BUILD_DIR) && host-perl/miniperl installperl \
		--destdir=$(PKG_INSTALL_DIR))
	chmod -R +w $(PKG_INSTALL_DIR)
	sh $(PKG_DIR)/files/deletepod.sh $(PKG_INSTALL_DIR)
	sh $(PKG_DIR)/files/strippm.sh $(PKG_INSTALL_DIR)
	$(RSTRIP) $(PKG_INSTALL_DIR)
	touch $@

$(PKG_BUILD_DIR)/.configured: $(PKG_BUILD_DIR)/.stage1 $(PKG_BUILD_DIR)/.stage3
	touch $@

$(PKG_BUILD_DIR)/.built: $(PKG_BUILD_DIR)/.stage8
	touch $@

$(IPKG_PERL):
	install -d -m0755 $(IDIR_PERL)/usr/bin
	install -m0755 $(PKG_INSTALL_DIR)/usr/bin/perl$(PKG_VERSION) \
		$(IDIR_PERL)/usr/bin/
	ln -f $(IDIR_PERL)/usr/bin/perl$(PKG_VERSION) $(IDIR_PERL)/usr/bin/perl
	$(IPKG_BUILD) $(IDIR_PERL) $(PACKAGE_DIR)

# module package template
define ipkg_pm

$$(eval $$(call PKG_template,$(1),$(2),$(PKG_VERSION)-$(PKG_RELEASE),$(ARCH)))

$$(IPKG_$(1)):
	sh $(PKG_DIR)/files/install-module.sh \
		$(PKG_INSTALL_DIR)/usr/lib/perl5/5.8 \
		$$(IDIR_$(1))/usr/lib/perl5/5.8 \
		$(3)
	$(IPKG_BUILD) $$(IDIR_$(1)) $(PACKAGE_DIR)
endef

include $(PKG_DIR)/Makefile.modules

## perl 5.8.8-1

=== Makefile ===
# $Id: Makefile 4033 2006-06-21 02:32:39Z nbd $

include $(TOPDIR)/rules.mk

PKG_NAME:=perl
PKG_VERSION:=5.8.8
PKG_RELEASE:=1
PKG_MD5SUM:=a377c0c67ab43fd96eeec29ce19e8382

PKG_SOURCE_URL:=ftp://ftp.cpan.org/pub/CPAN/src/5.0 \
		ftp://ftp.mpi-sb.mpg.de/pub/perl/CPAN/src/5.0 \
		ftp://ftp.gmd.de/mirrors/CPAN/src/5.0 \
		ftp://ftp.funet.fi/pub/languages/perl/CPAN/src/5.0
PKG_SOURCE:=$(PKG_NAME)-$(PKG_VERSION).tar.bz2
PKG_CAT:=bzcat

PKG_BUILD_DEPENDS:=db, gdbm

PKG_BUILD_DIR:=$(BUILD_DIR)/perl/$(PKG_NAME)-$(PKG_VERSION)
PKG_INSTALL_DIR:=$(PKG_BUILD_DIR)/ipkg-install


include $(INCLUDE_DIR)/package.mk
include $(TOPDIR)/package/perlmod.mk
include perlmod.mk

# override the PERL_LDFLAGS
PERL_LDFLAGS=	-L$(STAGING_DIR)/lib -L$(STAGING_DIR)/usr/lib
# -Wl,-rpath ${PERL_PREFIX}/lib/perl5/$(PKG_VERSION)/$(PERL_ARCH)/CORE

PERL_POST_CONFIGURE_PATCHES=./files/Makefile-pp_hot.patch
PERL_SOURCE_DIR=${TOPDIR}/package/perl/files

GNU_TARGET_NAME=$(shell echo $(CONFIG_ARCH) | sed 's/"//g')-linux-uclibc

define Package/perl
  SECTION:=lang
  CATEGORY:=Languages
  URL:=http://www.cpan.org/
  MAINTAINER:=Christian Magnusson <mag@mag.cx>
  TITLE:=Perl language
endef

define Build/Configure
endef

define Build/Compile
	@echo
	@echo "===> Stage 1: Configure host perl"
	@echo
	rm -rf $(PERL_HOST_BUILD_DIR)
	cp -Rp $(PKG_BUILD_DIR) $(PERL_HOST_BUILD_DIR)
	(cd $(PERL_HOST_BUILD_DIR); \
		rm -f config.sh Policy.sh; \
		sh ./Configure -des \
			-Dinstallstyle='lib/perl5' \
			-Darchname=$(PERL_ARCH) \
			-Dstartperl='#!$(PERL_PREFIX)/bin/perl' \
			-Dprefix=$(PERL_HOST_BUILD_DIR)/staging-install; \
	)

	@echo
	@echo "===> Stage 2: Build host perl binary with static extensions"
	@echo
	(cd $(PERL_HOST_BUILD_DIR); \
		make install.perl; \
	)

	@echo
	@echo "===> Stage 3: Configure target perl"
	@echo
	-$(MAKE) -C $(PKG_BUILD_DIR) clean
	sed -i -e '/LIBS/s|-L/usr/local/lib|-L$(STAGING_DIR)$(PERL_PREFIX)/lib|' $(PKG_BUILD_DIR)/ext/*/Makefile.PL
	# Errno.PL is stupidly hardwired to only look for errno.h in /usr/include
	sed -i.orig \
		-e 's:/usr/include/errno.h:$(STAGING_DIR)/include/errno.h:g' \
		-e '/^# *warn/s:^#::' \
		-e 's:= $$Config{cppstdin}:= $(TARGET_CROSS)gcc -E:' \
		$(PKG_BUILD_DIR)/ext/Errno/Errno_pm.PL
	ln -sf $(PERL_HOST_MINIPERL) $(PKG_BUILD_DIR)/hostperl
#	add this
#	ln -sf $(PERL_HOST_MINIPERL) $(STAGING_DIR)/usr/bin/hostperl
	( [ -e $(PERL_SOURCE_DIR)/Cross/config.sh-$(PERL_ARCH) ] && \
		cp -f $(PERL_SOURCE_DIR)/Cross/config.sh-$(PERL_ARCH) $(PKG_BUILD_DIR)/Cross/config.sh-$(GNU_TARGET_NAME) ) || \
	( [ -e $(PERL_SOURCE_DIR)/Cross/config.sh-$(GNU_TARGET_NAME) ] && \
		cp -f $(PERL_SOURCE_DIR)/Cross/config.sh-$(GNU_TARGET_NAME) $(PKG_BUILD_DIR)/Cross/ ) || \
		@echo "error finding config.sh-$(GNU_TARGET_NAME)"
	(cd $(PKG_BUILD_DIR)/Cross; \
		rm -f config; \
		printf "### Target Arch\nARCH = `echo $(GNU_TARGET_NAME) | sed s/-linux.*//`\n" > config; \
		printf "### Target OS\nOS = `echo $(GNU_TARGET_NAME) | sed s/.*-linux/linux/`\n" >> config; \
		cp -f $(PERL_SOURCE_DIR)/Cross/Makefile . ; \
		cp -f $(PERL_SOURCE_DIR)/Cross/Makefile.SH.patch . ; \
		CPPFLAGS="$(STAGING_CPPFLAGS) $(PERL_CPPFLAGS)" \
		LDFLAGS="$(STAGING_LDFLAGS) $(PERL_LDFLAGS)" \
		$(MAKE) patch perl_Configure; \
	)

	if test -n "$(PERL_POST_CONFIGURE_PATCHES)" ; then \
		cat $(PERL_POST_CONFIGURE_PATCHES) | patch -d $(PKG_BUILD_DIR) -p0 ; \
	fi

	@echo
	@echo "===> Stage 4: Build target perl binary"
	@echo
	(cd $(PKG_BUILD_DIR)/Cross; \
		$(TARGET_CONFIGURE_OPTS) \
		CFLAGS="$(TARGET_CFLAGS) $(CFLAGS_LARGEFILE) -I$(STAGING_DIR)/usr/include" \
		CPPFLAGS="-I$(STAGING_DIR)/usr/include" \
		LDFLAGS="-L$(STAGING_DIR)/usr/lib" \
		PATH="${PATH}:$(PKG_BUILD_DIR)" \
		$(MAKE) perl \
			PASTHRU_INC="$(TARGET_CFLAGS) $(PERL_CPPFLAGS) -I$(STAGING_DIR)/include -I$(STAGING_DIR)/usr/include" \
			OTHERLDFLAGS="-L$(STAGING_DIR)/usr/lib -rpath $(PERL_PREFIX)/lib" \
	)

	@echo
	@echo "===> Stage 5: Install Perl into staging dir"
	@echo
#	PATH="`dirname $(TARGET_CC)`:$(PKG_BUILD_DIR):${PATH}" 
	PATH="${PATH}:$(PKG_BUILD_DIR)" \
		$(MAKE) -C $(PKG_BUILD_DIR) DESTDIR=$(STAGING_DIR) INSTALL_DEPENDENCE="" install-strip
	for so in `find $(STAGING_DIR)$(PERL_PREFIX)/lib/perl5/ -name '*.so'`; do \
		chmod u+w ${so}; $(STRIP) ${so}; done
	(cd $(STAGING_DIR)$(PERL_PREFIX)/bin; \
		rm -f perl; \
		ln -s perl$(PKG_VERSION) perl; \
	)

	@echo
	@echo "===> Stage 6: Install Perl into a temporary root"
	@echo
#	PATH="`dirname $(TARGET_CC)`:$(PKG_BUILD_DIR):${PATH}" 
	PATH="${PATH}:$(PKG_BUILD_DIR)" \
		$(MAKE) -C $(PKG_BUILD_DIR) DESTDIR=$(PKG_INSTALL_DIR) INSTALL_DEPENDENCE="" install-strip
	for so in `find $(PKG_INSTALL_DIR)$(PERL_PREFIX)/lib/perl5/ -name '*.so'`; do \
		chmod u+w ${so}; $(STRIP) ${so}; done
	(cd $(PKG_INSTALL_DIR)$(PERL_PREFIX)/bin; \
		rm -f perl; \
		ln -s perl$(PKG_VERSION) perl; \
	)
endef

define Package/perl/install
	$(INSTALL_DIR) $(1)/opt/bin
	$(INSTALL_BIN) $(PKG_INSTALL_DIR)/opt/bin/perl$(PKG_VERSION) $(1)/opt/bin
	ln -f $(1)/opt/bin/perl$(PKG_VERSION) $(1)/opt/bin/perl
endef

$(eval $(call BuildPackage,perl))

-include perlbase.mk

=== files/Cross/Makefile ===
## Toplevel Makefile for cross-compilation of perl
#
## $Id: Makefile 3776 2006-08-12 22:28:36Z gda $

export TOPDIR=${shell pwd}
include $(TOPDIR)/config
export CFLAGS
export SYS=$(ARCH)-$(OS)
export CROSS=$(ARCH)-$(OS)-
# GCC bug http://gcc.gnu.org/bugzilla/show_bug.cgi?id=14279
# prevents using -O2 for all files when target is ia64, arm or powerpc
# see also https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=141694
export FULL_OPTIMIZATION = -fexpensive-optimizations -fomit-frame-pointer
#export OPTIMIZATION = -O2

export CC = $(CROSS)gcc
export CXX = $(CROSS)g++
export LD = $(CROSS)ld
export STRIP = $(CROSS)strip
export AR = $(CROSS)ar
export RANLIB = $(CROSS)ranlib


## Optimisation work
ifeq ($(ARCH),arm)
 ifdef CONFIG_TARGET_ARM_SA11X0
   ifndef Architecture
     Architecture = armv4l-strongarm
   endif
   FULL_OPTIMIZATION += -march=armv4 -mtune=strongarm1100 -mapcs-32
   OPTIMIZATION += -march=armv4 -mtune=strongarm1100 -mapcs-32
 endif
endif

CFLAGS+=$(FULL_OPTIMIZATION)

all:
	@echo Please read the README file before doing anything else.

gen_patch:
	diff -Bbur ../Makefile.SH Makefile.SH > Makefile.SH.patch
	diff -Bbur ../installperl installperl > installperl.patch

patch:
	cd .. ; if [ ! -e ./CROSS_PATCHED ] ; then \
		patch -p1 < Cross/Makefile.SH.patch; \
		patch -p1 < Cross/installperl.patch ; mv installperl installperl-patched; \
		sed -e 's/XXSTRIPXX/$(SYS)/' installperl-patched > installperl; \
		touch CROSS_PATCHED ; fi

dry_patch:
	cd .. ;	patch --dry-run -p1 < Cross/Makefile.SH.patch; \
		patch --dry-run -p1 < Cross/installperl.patch; \

perl_Configure:
	@echo Perl cross-build directory is $(TOPDIR)
	@echo Target arch is $(SYS)
	@echo toolchain: $(CC), $(CXX), $(LD), $(STRIP), $(AR), $(RANLIB)
	@echo Optimizations: $(FULL_OPTIMIZATION)
	$(TOPDIR)/generate_config_sh config.sh-$(SYS) > $(TOPDIR)/../config.sh
	cd $(TOPDIR)/.. ; ./Configure -S

perl:
	cd $(TOPDIR)/.. ; make depend ; make ; make more
	cd $(TOPDIR)/.. ; mkdir -p fake_config_library ; cp lib/Config.pm fake_config_library
	cd $(TOPDIR)/.. ; $(MAKE) more2 "PERLRUN=hostperl -I$(TOPDIR)/../fake_config_library -MConfig"
	cd $(TOPDIR)/.. ; $(MAKE) more3 "PERLRUN=hostperl -I$(TOPDIR)/../fake_config_library -MConfig"
	cd $(TOPDIR)/.. ; $(MAKE) more4 "PERLRUN=hostperl -I$(TOPDIR)/../fake_config_library -MConfig"
	cd $(TOPDIR)/.. ; rm -rf install_me_here
#	cd $(TOPDIR)/.. ; make install-strip
	cd $(TOPDIR)/.. ; sh -x Cross/warp

## perl 5.10.1

=== debian/changelog ===
perl (5.10.1-17ubuntu4) natty; urgency=low

  * debian/config.debian: pass multiarch paths to the build (if 
    available) so that we're able to find libraries needed to build.
    LP: #739693.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 30 Mar 2011 13:44:06 -0700

perl (5.10.1-17ubuntu3) natty; urgency=low

  * debian/config.over: Set i_libutil='undef', just in case libbsd-dev is
    installed at build time.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 15 Feb 2011 15:28:15 +0000

perl (5.10.1-17ubuntu2) natty; urgency=low

  * Backport fix from threads 1.35 to conditionally compile tmps stack
    cleanup code, fixing threads tests on ppc64.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 11 Feb 2011 19:30:53 +0000

perl (5.10.1-17ubuntu1) natty; urgency=low

  * Merge from debian unstable.  Remaining changes: (LP: #704391)
    - debian/control: Change build dependency from libdb4.7-dev
      to libdb-dev, to minimize the db versions on the CDs.
    - debian/patches/fixes/h2ph-gcc-4.5.diff:
      + Fix h2ph header generation with GCC 4.5. (Closes: #599933)

 -- Artur Rona <ari-tczew@ubuntu.com>  Tue, 18 Jan 2011 13:17:37 +0100

perl (5.10.1-17) unstable; urgency=medium

  * [SECURITY] CVE-2010-2761 CVE-2010-4410 CVE-2010-4411:
    fix CGI.pm MIME boundary and multiline header vulnerabilities.
    (Closes: #606995)

 -- Niko Tyni <ntyni@debian.org>  Fri, 07 Jan 2011 13:57:42 +0200

perl (5.10.1-16ubuntu1) natty; urgency=low

  * Resynchronise with Debian.  Remaining changes:
    - Change build dependency from libdb4.7-dev to libdb-dev, to minimize
      the db versions on the CDs.
    - Fix h2ph header generation with GCC 4.5.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 03 Nov 2010 16:03:31 +0000

perl (5.10.1-16) unstable; urgency=low

  * Improve LC_NUMERIC documentation. (Closes: #379329)
  * Fix sprintf not to ignore LC_NUMERIC with constants. (Closes: #601549)
  * Fix stack pointer corruption in pp_concat() with "use encoding".
    (Closes: #596105)

 -- Niko Tyni <ntyni@debian.org>  Tue, 02 Nov 2010 10:17:28 +0200

perl (5.10.1-15ubuntu2) natty; urgency=low

  * Apply upstream patch from Robin Barker
    (http://perl5.git.perl.org/perl.git/commit/8d66b3f930dc6d88b524d103e304308ae73a46e7)
    to fix h2ph header generation with GCC 4.5.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 12 Oct 2010 15:11:13 +0100

perl (5.10.1-15ubuntu1) natty; urgency=low

  * Resynchronise with Debian.  Remaining changes:
    - Change build dependency from libdb4.7-dev to libdb-dev, to minimize
      the db versions on the CDs.
  * Drop sparc optimisation change; Ubuntu no longer builds for sparc.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 12 Oct 2010 10:29:51 +0100

perl (5.10.1-15) unstable; urgency=low

  * Include the Text::Tabs license in debian/copyright. Thanks to "v.nix.is".
    (Closes: #596844)
  * Downgrade the 'make' recommendation to a suggestion to avoid pulling
    it in by default after all. (Closes: #596734) (Reopens: #293908)
  * Put the libfile-spec-perl conflict version in line with the separate
    package, which uses four digits. (Closes: #595121)
  * Squelch useless locale warnings during package maintainer scripts.
    (Closes: #508764)

 -- Niko Tyni <ntyni@debian.org>  Wed, 06 Oct 2010 21:45:00 +0300

perl (5.10.1-14) unstable; urgency=medium

  * Don't override -DDEBIAN on GNU/Hurd, fixing @INC breakage and other
    things. Thanks to Samuel Thibault. (Closes: #587901)
  * Fix builds on gcc 4.5 by passing PERL_PATCHLEVEL_H_IMPLICIT to cpp.
    Thanks to Loïc Minier and Paul Brook. (Closes: #588799)
  * Fix builds when the name of the current directory contains regexp
    metacharacters, particularly binNMUs with current sbuild versions.
    Thanks to Kyle Moffett and Ansgar Burchardt. (Closes: #585678)
  * Releasing with 'medium' urgency due to an RC bug fix.

 -- Niko Tyni <ntyni@debian.org>  Wed, 04 Aug 2010 13:52:05 +0300

perl (5.10.1-13) unstable; urgency=low

  * [SECURITY] CVE-2010-1974: Update to Safe-2.25, fixing code injection
    and execution vulnerabilities. (Closes: #582978)
  * Add conflicts/replaces/provides for the new libswitch-perl,
    libclass-isa-perl, and libpod-plainer-perl packages. (See #580034)
  * Fix a tell() crash on bad arguments. (Closes: #578577)
  * Fix a format/write crash. (Closes: #579537)
  * Prevent gcc from optimizing the u32align check away, finally fixing
    MD5 on armel. Thanks to Marc Pignat. (Closes: #289884)
  * Fix a test failure in CGI/t/fast.t when FCGI is available.

 -- Niko Tyni <ntyni@debian.org>  Sun, 30 May 2010 11:09:48 +0300

perl (5.10.1-12ubuntu2) maverick; urgency=low

  * debian/config.debian: merge fix from Paul Brook to make configure define
    PERL_PATCHLEVEL_H_IMPLICIT so that patchlevel.h does not require
    git_version; fixes the build with recent GCCs where gcc -E fails on
    missing includes; LP: #600951.

 -- Loïc Minier <loic.minier@ubuntu.com>  Mon, 12 Jul 2010 12:31:10 +0200

perl (5.10.1-12ubuntu1) maverick; urgency=low

  * Resynchronise with Debian.  Remaining changes:
    - Change build dependency from libdb4.7-dev to libdb-dev, to minimize
      the db versions on the CDs.
    - On sparc, build with -O1 instead of -O2.  See #438876.
  * Drop Breaks against doc-base.  We no longer need to upgrade directly
    from hardy.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 04 May 2010 16:32:38 +0100

perl (5.10.1-12) unstable; urgency=low

  * Fix the location of an Archive::Tar test file.
  * Update conflict versions on libscalar-list-utils-perl, libxsloader-perl,
    and libnet-perl.
  * Properly include the 5.10.0 site directories on @INC as per Perl policy.
    (Closes: #575030)
  * Fix an errno stringification bug in taint mode. (Closes: #574129) 
  * Move Config_heavy.pl into perl-base and unapply the DynaLoader
    changes introduced in 5.10.1-5. (Closes: #575308)
  * Remove B and B::Deparse from perl-base, they haven't worked without


=== debian/watch ===
version=2
http://www.perl.com/CPAN/src/5.0/ (?:.*/)?perl-(5\.\d*[02468](?:\.[\d.]+)?)\.tar\.gz debian uupdate
